<?php
  include "config.php";
  include "helper.php";

  if (is_logged_in()) {
    header("Location: index.php");
    exit();
  }

  $u = "";
  $p = "";

  if ($_SERVER["REQUEST_METHOD"] === "POST") {
    $u = strtolower(str_replace(" ", "", $_POST["username"]));
    $p = $_POST["password"];

    if (!($u && $p)) {
      $err = "Bad request, missing username or password parameter";
    } else if (strlen($u) > 64 || strlen($u) === 0) {
      $err = "Username must be 1-64 chars";
    } else if (!preg_match("/^[a-z0-9_-]{1,64}$/", $u)) {
      $err = "Username can only include a-z, 0-9, _, and -";
    } else {
      $query = "SELECT password_hash FROM users WHERE username='$u' LIMIT 1;";

      $response = pg_query($db, $query);

      if (pg_num_rows($response) === 0) {
        $err = "User '" . htmlspecialchars($u) . "' not found";
      } else {
        $user = pg_fetch_array($response);
        if (password_verify($p, $user["password_hash"])) {
          setcookie(
            "token",
            $token,
            time() + 60 * 60 * 24 * 30 * 265 // 1 year from now
          );
          header("Location: index.php");
          exit();
        } else {
          $err = "Incorrect password";
        }
      }
    }
  }

  $title = "Log In";
  include "boilerplate/head.php";
?>

<form method="POST">
  <div><input placeholder="Username" name="username" value="<?php echo htmlspecialchars($u); ?>" maxlength="64" required></div>
  <div><input placeholder="Password" name="password" type="password" value="<?php echo htmlspecialchars($p); ?>" required></div>
  <div><input type="submit" value="Log in"></div>
</form>

<?php
  $q = "SELECT count(*) FROM users LIMIT 1;";

  if ($signups !== false || ($signups === false && pg_fetch_array(pg_query($db, $q))["count"] !== 0)) {
    echo "<p><a href=\"signup.php\">Sign up instead?</a></p>";
  }

  include "boilerplate/foot.php";
?>
